﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DialogueEditor
{
    public partial class ManageMemory : Form
    {
        DialogueEditor parent;
        bool changing;

        public ManageMemory(DialogueEditor parent)
        {
            InitializeComponent();
            this.parent = parent;
            changing = false;
            parent.CheckAvailableBanks();
            TB_B1Cur.Text = (parent.startbanks[0] + 0xC00000).ToString("X6").Substring(0, 2);
            TB_B2Cur.Text = (parent.startbanks[1] + 0xC00000).ToString("X6").Substring(0, 2);
            TB_B3Cur.Text = (parent.startbanks[2] + 0xC00000).ToString("X6").Substring(0, 2);

            CBO_B1Move.Items.Add("None");
            CBO_B2Move.Items.Add("None");
            CBO_B3Move.Items.Add("None");
            foreach(int ad in parent.AvailableBanks)
            {
                CBO_B1Move.Items.Add((ad + 0xC00000).ToString("X6").Substring(0, 2));
                CBO_B2Move.Items.Add((ad + 0xC00000).ToString("X6").Substring(0, 2));
                CBO_B3Move.Items.Add((ad + 0xC00000).ToString("X6").Substring(0, 2));
            }
        }

        private void BTN_Close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void BTN_Save_Click(object sender, EventArgs e)
        {
            if(!(CBO_B1Move.SelectedItem == null || CBO_B1Move.SelectedIndex == 0))
            {
                parent.startbanks[0] = int.Parse((CBO_B1Move.SelectedItem.ToString() + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;
                parent.maxoffsets[0] = CBO_B1Move.SelectedItem.ToString() == "CE" ? 0xF0FF : 0xFFFF;
                if (CB_B1Erase.Checked)
                {
                    int startaddr = int.Parse((TB_B1Cur.Text + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;                    
                    int endaddr = TB_B1Cur.Text == "CE" ? startaddr + 0xF0FF : startaddr + 0xFFFF;
                    parent.EraseData(startaddr, endaddr);
                }
            }
            if (!(CBO_B2Move.SelectedItem == null || CBO_B2Move.SelectedIndex == 0))
            {
                parent.startbanks[1] = int.Parse((CBO_B2Move.SelectedItem.ToString() + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;
                parent.maxoffsets[1] = CBO_B2Move.SelectedItem.ToString() == "CE" ? 0xF0FF : 0xFFFF;
                if (CB_B2Erase.Checked)
                {
                    int startaddr = int.Parse((TB_B2Cur.Text + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;
                    int endaddr = TB_B2Cur.Text == "CE" ? startaddr + 0xF0FF : startaddr + 0xFFFF;
                    parent.EraseData(startaddr, endaddr);
                }
            }
            if (!(CBO_B3Move.SelectedItem == null || CBO_B3Move.SelectedIndex == 0))
            {
                parent.startbanks[2] = int.Parse((CBO_B3Move.SelectedItem.ToString() + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;
                parent.maxoffsets[2] = CBO_B3Move.SelectedItem.ToString() == "CE" ? 0xF0FF : 0xFFFF;
                if (CB_B3Erase.Checked)
                {
                    int startaddr = int.Parse((TB_B3Cur.Text + "0000"), System.Globalization.NumberStyles.AllowHexSpecifier) - 0xC00000;
                    int endaddr = TB_B3Cur.Text == "CE" ? startaddr + 0xF0FF : startaddr + 0xFFFF;
                    parent.EraseData(startaddr, endaddr);
                }
            }

            parent.WriteToData();

            parent.ReadFromData();

            parent.NeedsSave(true);

            this.Close();
        }

        private void CBO_B1Move_SelectedIndexChanged(object sender, EventArgs e)
        {
           
            ComboBox changed = (ComboBox)sender;
            string cb1sel = CBO_B1Move.SelectedItem == null || CBO_B1Move.SelectedIndex == 0 ? "" : CBO_B1Move.SelectedItem.ToString();
            string cb2sel = CBO_B2Move.SelectedItem == null || CBO_B2Move.SelectedIndex == 0 ? "" : CBO_B2Move.SelectedItem.ToString();
            string cb3sel = CBO_B3Move.SelectedItem == null || CBO_B2Move.SelectedIndex == 0 ? "" : CBO_B3Move.SelectedItem.ToString();

            if(cb1sel == cb2sel && !(cb1sel == "" || cb2sel == "")
                || cb1sel == cb3sel && !(cb1sel == "" || cb3sel == "")
                || cb2sel == cb3sel && !(cb2sel == "" || cb3sel == ""))
            {
                MessageBox.Show("Cannot select the same bank for two different blocks.");
                changed.SelectedIndex = 0;
            }
                
            
        }
    }
}
